unit TampilanDataAccelDanGyroDelphi;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CPort, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    ComPort1: TComPort;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    procedure Button2Click(Sender: TObject);
    procedure ComPort1RxChar(Sender: TObject; Count: Integer);
    procedure SerialProcess();
    procedure Split(const Delimiter: Char; Input: string;
    const Strings: TStrings) ;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  save_accelX, save_accelY, save_accelZ : string;
  save_gyroX, save_gyroY, save_gyroZ : string;
  DataBuffer : string;

implementation

{$R *.dfm}
procedure TForm1.SerialProcess;
begin
  edit1.Text := save_accelX;
  edit2.Text := save_accelY;
  edit3.Text := save_accelZ;
  edit4.Text := save_gyroX;
  edit5.Text := save_gyroY;
  edit6.Text := save_gyroZ;
end;

procedure TForm1.Split(const Delimiter: Char; Input: string;
const Strings: TStrings) ;
begin
   Assert(Assigned(Strings));
   Strings.Clear;
   Strings.Delimiter := Delimiter;
   Strings.DelimitedText := Input;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ComPort1.Open();

  if ComPort1.Connected then
  begin
    button1.Enabled := true;
  end
  else ShowMessage('Your Connection Failed.');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ComPort1.ShowSetupDialog();
  button1.Enabled := true;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ComPort1.Close();
  form1.Close();
end;

procedure TForm1.ComPort1RxChar(Sender: TObject; Count: Integer);
var
  DataByte : string;
  x : integer;
  save_data : TStringList;

begin
  ComPort1.ReadStr(DataByte, Count);
  DataBuffer := dataBuffer + DataByte;

  x := Pos('n', DataBuffer);
  if x = 0 then Exit;

  save_data := TStringList.Create;
  try
    repeat
      DataByte := Copy(DataBuffer, 1, x-1);
      delete(DataBuffer, 1, x);

      Memo1.Text := dataByte;

      Split(' ', DataByte, save_data);
      if save_data.Count >= 6 then
      begin
        save_gyroX := save_data[0];
        save_gyroY := save_data[1];
        save_gyroZ := save_data[2];
        save_accelX := save_data[3];
        save_accelY := save_data[4];
        save_accelZ := save_data[5];
        SerialProcess();
      end;

      x := Pos('n', DataBuffer);
    until x = 0;
  finally
    save_data.Free;
  end;
end;

end.

