#ifndef _Accel2Spi_H_INCLUDED
#define _Accel2Spi_H_INCLUDED

#include <stdio.h>
#include <Arduino.h>
#include <avr/pgmspace.h>

#define SPI_CLOCK_DIV4 0x00
#define SPI_CLOCK_DIV16 0x01
#define SPI_CLOCK_DIV64 0x02
#define SPI_CLOCK_DIV128 0x03
#define SPI_CLOCK_DIV2 0x04
#define SPI_CLOCK_DIV8 0x05
#define SPI_CLOCK_DIV32 0x06
//#define SPI_CLOCK_DIV64 0x07

#define SPI_MODE0 0x00
#define SPI_MODE1 0x04
#define SPI_MODE2 0x08
#define SPI_MODE3 0x0C

#define SPI_MODE_MASK 0x0C  // CPOL = bit 3, CPHA = bit 2 on SPCR
#define SPI_CLOCK_MASK 0x03  // SPR1 = bit 1, SPR0 = bit 0 on SPCR
#define SPI_2XCLOCK_MASK 0x01  // SPI2X = bit 0 on SPSR

void setOffsetValueAccel(unsigned char address,unsigned int value);
void writeRegisterValueByteAccel(unsigned char address,unsigned char value);
void setModeControl(unsigned char value);
unsigned char readRegisterValueByteAccel(unsigned char address);
unsigned int readRegisterValueWordAccel(unsigned char address);
void TenBitTwoComplementToSignAndValue(unsigned int input,unsigned char* sign, unsigned int* value);
unsigned int SignAndValueToTwoComplementOffset(unsigned char sign,unsigned int value);

void movingAverage(int dataX, int dataY, int dataZ);
void average(int dataX, int dataY, int dataZ);

void SerialAccel1(int signx, int accelx, int signy, int accely, int signz, int accelz);
void SerialAccel2(int signx, int accelx, int signy, int accely, int signz, int accelz);

void spiAccel_init();

#endif