#define SCL_PORT  PORTD
#define SCL_PIN  3
#define SDA_PORT  PORTD
#define SDA_PIN  4
#include <SoftI2CMaster.h>
#include "GyroI2C.h"

int x_gyro,y_gyro,z_gyro;
unsigned char a,b,c,d,e,f;

// settting gyroscope
void writeRegisterValueByteGyro(unsigned char I2Caddress,unsigned char address,unsigned char value) {
    i2c_start(I2Caddress);
    i2c_write(address);
    i2c_write(value);
    i2c_stop();
}

unsigned char readRegisterValueByteGyro(unsigned char address, unsigned char ack) {
        unsigned char value;
        
        i2c_start(0xD0);
        i2c_write(address);
        i2c_stop();

        i2c_start(0xD1);
        value = i2c_read(ack);
        i2c_stop();  
        
        return value;
} 

void readL3G4200D(void) {

        a = readRegisterValueByteGyro(0x28,1);
        b = readRegisterValueByteGyro(0x29,1);
        c = readRegisterValueByteGyro(0x2A,1);
        d = readRegisterValueByteGyro(0x2B,1);
        e = readRegisterValueByteGyro(0x2C,1);
        f = readRegisterValueByteGyro(0x2D,0);        

        x_gyro = (int)b; 
        x_gyro = x_gyro << 8;   
        x_gyro |= a;    
        x_gyro = x_gyro /128;
        
        y_gyro = (int)d; 
        y_gyro = y_gyro << 8;   
        y_gyro |=c;
        y_gyro = y_gyro /128;
        
        z_gyro = (int)f; 
        z_gyro = z_gyro << 8;   
        z_gyro |= e;
        z_gyro = z_gyro /128;

}

void SerialGyro1()
{
  Serial.write(x_gyro >> 8);
  Serial.write(x_gyro);
  Serial.write(y_gyro >> 8);
  Serial.write(y_gyro);
  Serial.write(z_gyro >> 8);
  Serial.write(z_gyro);
}

void SerialGyro2()
{
  Serial.print(x_gyro);
  Serial.print(' ');
  Serial.print(y_gyro);
  Serial.print(' ');
  Serial.print(z_gyro); 
}

void gyroi2c_init()
{
	i2c_init();
}