#define SCL_PORT  PORTD
#define SCL_PIN  3
#define SDA_PORT  PORTD
#define SDA_PIN  4
#include <SoftI2CMaster.h>
#include "SettingAccelI2C.h"

unsigned int inX[100], inY[100], inZ[100];

//setting accelerometer 
void setOffsetValueAccel(unsigned char address,unsigned int value) {
    i2c_start(0x3A);
    i2c_write(address);
    i2c_write(value%256);
    i2c_write(value/256);
    i2c_stop();
}

void writeRegisterValueByteAccel(unsigned char address,unsigned char value) {
   i2c_start(0x3A);
   i2c_write(address);
   i2c_write(value);
   i2c_stop();
}

void setModeControl(unsigned char value) {
    writeRegisterValueByteAccel(0x16,value);   
}

unsigned char readRegisterValueByteAccel(unsigned char address) {   
   unsigned char retValue = 0x00;
   
   i2c_start(0x3A);
   i2c_write(address);
   i2c_stop();

   i2c_start(0x3B);
   retValue = i2c_read(0);
   i2c_stop();
   
   return retValue;  
}

unsigned int readRegisterValueWordAccel(unsigned char address) {
        unsigned int value,tempValue; 
        
        i2c_start(0x3A);
        i2c_write(address);
        i2c_stop();

        i2c_start(0x3B);
        tempValue = i2c_read(1);
        value = i2c_read(0);
        i2c_stop();  
   
        value = value << 8;
        value += tempValue;
        
        return value;
}

void TenBitTwoComplementToSignAndValue(unsigned int input,unsigned char* sign,
unsigned int* value) {
    if ((input & 0x0200)==0x0200) {       
        *sign = '-'; 
        input = ~input;   
        input = input & 0x01FF;
        input = input + 1;        
        *value = input;            
    }               
    else {
        *sign = '+'; 
        *value = input;
    }
}

unsigned int SignAndValueToTwoComplementOffset(unsigned char sign,unsigned int value) {

    if (sign=='-') {       
        value = ~value;
        value = value + 1;
        value = value & 0x7FF;
    }               
    return value;
}

// filter
void movingAverage(int dataX, int dataY, int dataZ)
{
  int inputX, inputY, inputZ;           
    inX[0] = dataX;
    inY[0] = dataY;
    inZ[0] = dataZ;
    //Low pass filter
    inputX = inX[0]*1 + inX[1]*3 + inX[2]*5 + inX[3]*3 + inX[4]*1;
    inputY = inY[0]*1 + inY[1]*3 + inY[2]*5 + inY[3]*3 + inY[4]*1;
    inputZ = inZ[0]*1 + inZ[1]*3 + inZ[2]*5 + inZ[3]*3 + inZ[4]*1;
    dataX = inputX/13;
    dataY = inputY/13;
    dataZ = inputZ/13;
    
    inX[4] = inX[3];
    inX[3] = inX[2];
    inX[2] = inX[1];
    inX[1] = inX[0]; 
    inY[4] = inY[3];
    inY[3] = inY[2];
    inY[2] = inY[1];
    inY[1] = inY[0]; 
    inZ[4] = inZ[3];
    inZ[3] = inZ[2];
    inZ[2] = inZ[1];
    inZ[1] = inZ[0];    
}

void average(int dataX, int dataY, int dataZ)
{
  int inputX, inputY, inputZ;
  const int length = 100;
  
  inX[0] = dataX;
  inY[0] = dataY;
  inZ[0] = dataZ;
    
  for(int i=0; i < length; i++)
  {
    inputX += inX[i];
    inputY += inY[i];
    inputZ += inZ[i];
  }
  
  dataX = inputX/length;
  dataY = inputY/length;
  dataZ = inputZ/length;
  
  for(int i=length-2; i >= 0; i--)
  {
    inX[i+1] = inX[i];
    inY[i+1] = inY[i];
    inZ[i+1] = inZ[i];
  }
}

void SerialAccel1(int signx, int accelx, int signy, int accely, int signz, int accelz)
{
  Serial.write(signx);
  Serial.write(accelx >> 8);
  Serial.write(accelx);
  Serial.write(signy);
  Serial.write(accely >> 8);
  Serial.write(accely);
  Serial.write(signz);
  Serial.write(accelz >> 8);
  Serial.write(accelz);
}

void SerialAccel2(int signx, int accelx, int signy, int accely, int signz, int accelz)
{
  Serial.print(' ');
  Serial.print(char(signx));
  Serial.print(accelx);
  Serial.print(' ');
  Serial.print(char(signy));
  Serial.print(accely);
  Serial.print(' ');
  Serial.print(char(signz));
  Serial.print(accelz);
}

void I2CAccel_init()
{
  i2c_init();
}