#include <SettingGyroSPI.h>
#include <SettingAccelI2C.h>
//#include <GyroI2C.h>
//#include <Accel2Spi.h>

unsigned int x,y,z,valueX,valueY,valueZ,offsetX,offsetY,offsetZ;
unsigned char modeControl,signX,signY,signZ;

void setup(void)
{
  // set up SPI
  //spiAccel_init();
  gyroSpi_init();
  // set up I2C
  //gyroi2c_init();
  I2CAccel_init();
  // set up UART
  Serial.begin(9600);
  delay(100);

  // Pengaturan MMA7455 (accelerometer) 
  setModeControl(0x05); // setting g-range to 2g
  modeControl = readRegisterValueByteAccel(0x16);

  offsetX = SignAndValueToTwoComplementOffset('+',6);
  offsetY = SignAndValueToTwoComplementOffset('+',60);
  offsetZ = SignAndValueToTwoComplementOffset('-',15);

  setOffsetValueAccel(0x10,offsetX); 
  setOffsetValueAccel(0x12,offsetY);
  setOffsetValueAccel(0x14,offsetZ);

  // setting L3G4200D (gyroscoppe)
  //writeRegisterValueByteGyro(0xD0,0x20,0x0F); //Just for I2C
  writeRegisterValueByteGyro(0x20,0x0F);  // Just for SPI 
}

void loop(void)
{ 
  // Proses pengambilan data MMA7455 (accelerometer)
  x = readRegisterValueWordAccel(0x00);
  y = readRegisterValueWordAccel(0x02);
  z = readRegisterValueWordAccel(0x04);                                                         
  TenBitTwoComplementToSignAndValue(x,&signX,&valueX);    
  TenBitTwoComplementToSignAndValue(y,&signY,&valueY);
  TenBitTwoComplementToSignAndValue(z,&signZ,&valueZ);
  //movingAverage(valueX, valueY, valueZ);
  average(valueX, valueY, valueZ);

  // Proses pengambilan data gyroscope 
  readL3G4200D();

  //Serial.write('a');
  //Serial.write(125);
  Serial.print('n');
  //SerialGyro1();
  SerialGyro2();
  //SerialAccel1(signX, valueX, signY, valueY, signZ, valueZ);
  SerialAccel2(signX, valueX, signY, valueY, signZ, valueZ);  
}

